#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <emmintrin.h>
#include <smmintrin.h>

#define BLOCKLEN 1024
#define MEMLEN (1 << 27)
#define STATESIZE 16

int main() {
    // Allocate memory
    __m128i *mem;
    if(posix_memalign((void *)&mem,  64, (uint64_t)STATESIZE*MEMLEN)) {
        fprintf(stderr, "Unable to allocate memory\n");
        return false;
    }
    __m128i counter = _mm_set_epi32(0, 0, 0, 0);
    __m128i delta = _mm_set_epi32(1, 1, 1, 1);
    //__m128i buf[BLOCKLEN];
    for(uint32_t i = 0; i < BLOCKLEN; i++) {
        //buf[i] = delta;
        mem[i] = delta;
    }
    for(uint32_t l = 0; l < 1; l++) {
        __m128i *p = (__m128i *)mem + BLOCKLEN;
        for(uint32_t i = 1; i < MEMLEN/BLOCKLEN; i++) {
            //__m128i *prev = buf;
            __m128i *prev = p - BLOCKLEN;
            uint32_t randVal = *(uint32_t *)prev;
            __m128i *from = (__m128i *)mem + (randVal % (i *BLOCKLEN));
            for(uint32_t j = 0; j < BLOCKLEN; j++) {
                counter = _mm_add_epi32(counter, *prev++);
                counter = _mm_add_epi32(counter, *from++);
                //*prev++ = counter;
                //_mm_stream_si128(p++, counter);
                *p++ = counter;
            }
        }
    }
    uint32_t *m = (uint32_t *)mem;
    printf("mem %u\n", m[rand() % (1 << 29)]);
    free(mem);
    return 0;
}
